<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible" width="800px">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item :label="t('EquipmentManagement.DvSubject.projectCode')" prop="subjectCode">
        <el-input
          v-model="formData.subjectCode"
          :placeholder="t('EquipmentManagement.DvSubject.placeholderProjectCode')"
          :disabled="formType === 'update'"
        />
      </el-form-item>
      <el-form-item :label="t('EquipmentManagement.DvSubject.projectName')" prop="subjectName">
        <el-input
          v-model="formData.subjectName"
          :placeholder="t('EquipmentManagement.DvSubject.placeholderProjectName')"
        />
      </el-form-item>
      <el-form-item :label="t('EquipmentManagement.DvSubject.inspectionMethod')" prop="inspectionMethod">
        <el-select
          v-model="formData.inspectionMethod"
          :placeholder="t('EquipmentManagement.DvSubject.placeholderInspectionMethod')"
          clearable
          filterable
          class="!w-full"
        >
          <el-option v-for="dict in inspectionMethodOptions" :key="dict.value" :label="dict.label" :value="dict.value" />
        </el-select>
      </el-form-item>
      <el-form-item :label="t('EquipmentManagement.DvSubject.valueType')" prop="valueType">
        <el-select
          v-model="formData.valueType"
          :placeholder="t('EquipmentManagement.DvSubject.placeholderValueType')"
          clearable
          filterable
          class="!w-full"
        >
          <el-option v-for="dict in valueTypeOptions" :key="dict.value" :label="dict.label" :value="dict.value" />
        </el-select>
      </el-form-item>
      <el-form-item :label="t('EquipmentManagement.DvSubject.upperVal')" prop="upperVal" v-if="formData.valueType == 0">
        <el-input-number
          v-model="formData.upperVal"
          :placeholder="t('EquipmentManagement.DvSubject.placeholderUpperVal')"
          class="!w-full"
          :precision="2" 
          :step="0.01"
        />
      </el-form-item>
      <el-form-item :label="t('EquipmentManagement.DvSubject.lowerVal')" prop="lowerVal" v-if="formData.valueType == 0">
        <el-input-number
          v-model="formData.lowerVal"
          :placeholder="t('EquipmentManagement.DvSubject.placeholderLowerVal')"
          class="!w-full"
          :precision="2" 
          :step="0.01"
        />
      </el-form-item>
      <el-form-item :label="t('EquipmentManagement.DvSubject.judgmentCriteria')" prop="judgmentCriteria">
        <el-input
          v-model="formData.judgmentCriteria"
          :placeholder="t('EquipmentManagement.DvSubject.placeholderJudgmentCriteria')"
          type="textarea"
        />
      </el-form-item>
      <el-form-item :label="t('EquipmentManagement.DvSubject.isEnable')" prop="isEnable">
        <el-radio-group v-model="formData.isEnable">
          <el-radio v-for="dict in getBoolDictOptions(DICT_TYPE.INFRA_BOOLEAN_STRING)" :key="dict.value" :label="dict.value">
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">{{ t('common.ok') }}</el-button>
      <el-button @click="dialogVisible = false">{{ t('common.cancel') }}</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { getBoolDictOptions, getStrDictOptions, DICT_TYPE } from '@/utils/dict'
import { DvSubjectApi, DvSubjectVO } from '@/api/mes/dvsubject'
import { useDictStoreWithOut } from '@/store/modules/dict'

/** 维保项目 表单 */
defineOptions({ name: 'DvSubjectForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dictStore = useDictStoreWithOut()
const dictReady = ref(false)

const inspectionMethodOptions = computed(() => (dictReady.value ? getStrDictOptions('Inspection_method') : []))
const valueTypeOptions = computed(() => (dictReady.value ? getStrDictOptions('value_types') : []))

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  subjectCode: undefined,
  subjectName: undefined,
  isEnable: undefined,
  inspectionMethod: undefined,
  valueType: undefined,
  judgmentCriteria: undefined,
  upperVal: undefined,
  lowerVal: undefined
})
const formRules = reactive({
  subjectCode: [{ required: true, message: '项目编码不能为空', trigger: 'blur' }],
  subjectName: [{ required: true, message: '项目名称不能为空', trigger: 'blur' }],
  inspectionMethod: [{ required: true, message: '检验方式不能为空', trigger: 'change' }],
  valueType: [{ required: true, message: '值类型不能为空', trigger: 'change' }],
  // judgmentCriteria: [{ required: true, message: '判定基准不能为空', trigger: 'blur' }],
  isEnable: [{ required: true, message: '是否启用不能为空', trigger: 'change' }],
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  if (!dictReady.value) {
    await dictStore.setDictMap()
    dictReady.value = true
  }
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await DvSubjectApi.getDvSubject(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = {
      id: formType.value === 'update' ? formData.value.id : undefined,
      subjectCode: formData.value.subjectCode,
      subjectName: formData.value.subjectName,
      isEnable: formData.value.isEnable,
      inspectionMethod: formData.value.inspectionMethod,
      valueType: formData.value.valueType,
      judgmentCriteria: formData.value.judgmentCriteria,
      upperVal: formData.value.upperVal,
      lowerVal: formData.value.lowerVal
    } as unknown as DvSubjectVO
    if (formType.value === 'create') {
      await DvSubjectApi.createDvSubject(data)
      message.success(t('common.createSuccess'))
    } else {
      await DvSubjectApi.updateDvSubject(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    subjectCode: undefined,
    subjectName: undefined,
    isEnable: true,
    inspectionMethod: undefined,
    valueType: undefined,
    judgmentCriteria: undefined,
    upperVal: undefined,
    lowerVal: undefined
  }
  formRef.value?.resetFields()
}
</script>
